<?php
/*
	Сортировка дочерних страниц относительно родительской - если задан парамтер
	tx_air_table_page_children_sorting (сортировать по названию, id, дате создания и т.д.)
*/
namespace AirTableHooks\AirTable\Tree\Pagetree;
class DataProvider extends \TYPO3\CMS\Backend\Tree\Pagetree\DataProvider {

	/**
	 * Returns all sub-pages of a given id
	 *
	 * @param integer $id
	 * @param string $searchFilter
	 * @return array
	 */
	protected function getSubpages($id, $searchFilter = '') {
		#$where = $this->getWhereClause($id, $searchFilter);
		#return $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('uid,t3ver_wsid', 'pages', $where, '', 'sorting', '', 'uid');
		$rec = \TYPO3\CMS\Backend\Utility\BackendUtility::getRecord('pages', $id, 'tx_air_table_page_children_sorting');
		if (!empty($rec['tx_air_table_page_children_sorting'])) { 
			// $new_sort = preg_replace('/\W+/', '', $rec['tx_air_table_page_children_sorting']); // защита от SQL-иньекций
			$new_sort = $rec['tx_air_table_page_children_sorting'];
			$where = $this->getWhereClause($id, $searchFilter);
			return $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('uid,t3ver_wsid', 'pages', $where, '', $new_sort, '', 'uid');
		} else {
			$where = $this->getWhereClause($id, $searchFilter);
			return $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('uid,t3ver_wsid', 'pages', $where, '', 'sorting', '', 'uid');
		}
	}

	/**
	 * Returns TRUE if the node has child's
	 *
	 * @param integer $id
	 * @return boolean
	 */
	/*
	protected function hasNodeSubPages($id) {
		#$where = $this->getWhereClause($id);
		#$subpage = $GLOBALS['TYPO3_DB']->exec_SELECTgetSingleRow('uid', 'pages', $where, '', 'sorting', '', 'uid');
		#$returnValue = TRUE;
		#if (!$subpage['uid']) {
		#	$returnValue = FALSE;
		#}
		#return $returnValue;
	}
	*/

}


?>
