<?php

/**
 * Class/Function which offers TCE main hook functions.
 *
 */

class tx_air_table_TCEmainHook {

	/**
	 * Function to set the colPos of an element depending on
	 * whether it is a child of a parent container or not
	 * will set colPos according to availability of the current grid column of an element
	 * 0 = no column at all
	 * -1 = grid element column
	 * -2 = non used elements column
	 * changes are applied to the field array of the parent object by reference
	 *
	 * @param	array           $fieldArray: The array of fields and values that have been saved to the datamap
	 * @param	str             $table: The name of the table the data should be saved to
	 * @param	int             $id: The uid of the page we are currently working on
	 * @param	\t3lib_TCEmain  $parentObj: The parent object that triggered this hook
	 * @return	void
	 *
	 */
	 
	/*
		Здесь данный хук понадобился что бы подставить стрктуры, т.к. config.internal_type = file
		не присоеденял файлы для таблиц где есть $GLOBALS['TCA'][$table]['multistructure'].
		См. public function process_datamap() { }
	*/
	public function processDatamap_preProcessFieldArray(&$fieldArray, $table, $id, &$parentObj) {
		// $row =  t3lib_befunc::getRecord($table, $id, "*");

			/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены) параметр "allowed_default_columns" */
			// Сохраняем оригинал колонок, что бы их восстановить оригинал значений
			if (!isset($GLOBALS['TCA_saveOriginal']['pages']['columns'])) {
				$GLOBALS['TCA_saveOriginal']['pages']['columns'] = $GLOBALS['TCA']['pages']['columns'];
			}
			$GLOBALS['TCA']['pages']['columns'] = $GLOBALS['TCA_saveOriginal']['pages']['columns'];
			/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены) параметр "allowed_default_columns" */	
		
				// Для таблиц NEW-TABLE-MULTISTRUCTURE - подставляем структуры
			if (isset($GLOBALS['TCA'][$table]['multistructure']) &&
			isset($GLOBALS['TCA'][$table]['ctrl']['type'])) {
			
					// Определяем какая структура указана для записи (новая - берем по умолчанию, либо берем из записи)
				if ($table == "pages") {
					$rowRecord =  t3lib_befunc::getRecord($table, $id, "doktype");
					$telemSelected = $rowRecord['doktype'];
					// Для элементов контента
				} elseif ($table == "tt_content") {
					$rowRecord =  t3lib_befunc::getRecord($table, $id, "CType");
					$telemSelected = $rowRecord['CType'];
				} else {
					// Для накопителей
					$rowRecord =  t3lib_befunc::getRecord($table, $id, "telem");
					$telemSelected = $rowRecord['telem'];
				}
				
					// При условии, что определили
					// Подставляем структуры и что это структура определена в "multistructure"
				if (isset($GLOBALS['TCA'][$table]['multistructure'][$telemSelected])) {
					$GLOBALS['TCA'][$table]['types'][$telemSelected]['showitem'] 
					= $GLOBALS['TCA'][$table]['multistructure'][$telemSelected]['types']['showitem'];
						
						// Проставляем колонки (т.к. title-колонок может отличаться)
					foreach ($GLOBALS['TCA'][$table]['multistructure'][$telemSelected]['types']['columns'] as $kProperty => $vProperty) {
						$GLOBALS['TCA'][$table]['columns'][$kProperty] = $vProperty;
					}
				}
				
				/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены) параметр "allowed_default_columns" */
				// Сохраняем оригинал колонок, что бы их восстановить оригинал значений
				/*
				Здесь это не нужно!
				if ($tablename == "pages" && isset($GLOBALS['TCA']['pages']['multistructure'][$telemSelected]['types']['allowed_default_columns'])) {
					$allowed_default_columns = $GLOBALS['TCA']['pages']['multistructure'][$telemSelected]['types']['allowed_default_columns'];
					$allowed_default_columns = explode(",", $allowed_default_columns);
					$tempColumns = $GLOBALS['TCA']['pages']['columns'];
					$tempColumnsNew = array();
					foreach ($tempColumns as $kC => $vC){
						if (in_array($kC, $allowed_default_columns)){ // $kC != 'starttime'
							$tempColumnsNew[$kC] = $vC;
						}
					}
					$GLOBALS['TCA']['pages']['columns'] = $tempColumnsNew;
				}
				*/
				/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены */
				
			}
			
				// Для таблиц NEW-PAGE-MODXTV - подставляем TV-поля
			if ($table == "pages" &&
		 	isset($GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV']) &&
			count($GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV']) > 0) {
				$rowRecord =  t3lib_befunc::getRecord('pages', $id, "doktype,module");
				$telemSelected = $rowRecord['doktype'];
				$moduleSelected = $rowRecord['module'];
				
					// При условии, что определили
					// Приклеиваем структуру TV-полей в конец
					// Исправляем небольшой баг что бы не приклеивались повторно после сохранения документа
				if (!strstr($GLOBALS['TCA']['pages']['types'][$telemSelected]['showitem'], "," . $GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'][$moduleSelected]['types']['showitem'])) {
					$GLOBALS['TCA']['pages']['types'][$telemSelected]['showitem'] 
					.= "," . $GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'][$moduleSelected]['types']['showitem'];
				}
				
					// Проставляем колонки (т.к. title-колонок может отличаться)
				foreach ($GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'][$moduleSelected]['types']['columns'] as $kProperty => $vProperty) {
					$GLOBALS['TCA']['pages']['columns'][$kProperty] = $vProperty;
				}
				
				/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены) параметр "allowed_default_columns" */
				/*
				Здесь это не нужно!
				if ($moduleSelected != NULL && isset($GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'][$moduleSelected]['types']['allowed_default_columns'])) {
					$allowed_default_columns = $GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'][$moduleSelected]['types']['allowed_default_columns'];
					$allowed_default_columns = explode(",", $allowed_default_columns);
					$tempColumns = $GLOBALS['TCA']['pages']['columns'];
					$tempColumnsNew = array();
					foreach ($tempColumns as $kC => $vC){
						if (in_array($kC, $allowed_default_columns)){ // $kC != 'starttime'
							$tempColumnsNew[$kC] = $vC;
						}
					}
					$GLOBALS['TCA']['pages']['columns'] = $tempColumnsNew;
				}
				*/
				/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены */
				
			}
			
	}

	/**
	 * Function to set the colPos of an element depending on
	 * whether it is a child of a parent container or not
	 * will set colPos according to availability of the current grid column of an element
	 * 0 = no column at all
	 * -1 = grid element column
	 * -2 = non used elements column
	 * changes are applied to the field array of the parent object by reference
	 *
	 * @param	array           $fieldArray: The array of fields and values that have been saved to the datamap
	 * @param	str             $table: The name of the table the data should be saved to
	 * @param	int             $id: The uid of the page we are currently working on
	 * @param	\t3lib_TCEmain  $parentObj: The parent object that triggered this hook
	 * @return	void
	 *
	 */
	# public function processDatamap_postProcessFieldArray($status, $table, $id, &$fieldArray, &$parentObj) {
	# 	// 
	# }

	/**
	 * Function to process the drag & drop copy action
	 *
	 * @param string            $command: The command to be handled by the command map
	 * @param string            $table: The name of the table we are working on
	 * @param int               $id: The id of the record that is going to be copied
	 * @param string            $value: The value that has been sent with the copy command
	 * @param boolean           $commandIsProcessed: A switch to tell the parent object, if the record has been copied
	 * @param \t3lib_TCEmain    $parentObj: The parent object that triggered this hook
	 * @return	void
	 *
	 */
	# public function processCmdmap($command, $table, $id, $value, &$commandIsProcessed, &$parentObj) {
	# 	// 
	# }

}

?>