<?php

/**
 * Hook into t3lib_TCEforms::dbFileIcons
 */
require_once(PATH_t3lib.'interfaces/interface.t3lib_tceforms_dbfileiconshook.php');
class tx_air_table_dbfileicons_fal_edit_icon implements t3lib_TCEforms_dbFileIconsHook {

	/**
	 * Modifies the parameters for selector box form-field for the db/file/select elements (multiple)
	 *
	 * @param	array			$params				An array of additional parameters, eg: "size", "info", "headers" (array with "selector" and "items"), "noBrowser", "thumbnails"
	 * @param	string			$selector			Alternative selector box.
	 * @param	string			$thumbnails			Thumbnail view of images. Only filled if there are images only. This images will be shown under the selectorbox.
	 * @param	array			$icons				Defined icons next to the selector box.
	 * @param	string			$rightbox			Thumbnail view of images. Only filled if there are other types as images. This images will be shown right next to the selectorbox.
	 * @param	string			$fName				Form element name
	 * @param	array			$uidList			The array of item-uids. Have a look at t3lib_TCEforms::dbFileIcons parameter "$itemArray"
	 * @param	array			$additionalParams	Array with additional parameters which are be available at method call. Includes $mode, $allowed, $itemArray, $onFocus, $table, $field, $uid. For more information have a look at PHPDoc-Comment of t3lib_TCEforms::dbFileIcons
	 * @param	t3lib_TCEforms	$parentObject		parent t3lib_TCEforms object
	 * @return	void
	 */
	public function dbFileIcons_postProcess(array &$params, &$selector, &$thumbnails, array &$icons, &$rightbox, &$fName, array &$uidList, array $additionalParams, t3lib_TCEforms $parentObject) {

		// data[tx_infoblock_elements_students][8][image_pic]
		preg_match_all('/\[([a-z_0-9]+)\]/is', $fName, $match);
		/*
			Array
			(
				[0]
				[1] => Array
				(
					[0] => tx_infoblock_elements_students
					[1] => 8
					[2] => image_pic
				)

			)
		*/
		$tableName = $match[1][0];
		$idRecord = $match[1][1];
		$fieldName = $match[1][2];
		$fieldConf = $GLOBALS['TCA'][$tableName]['columns'][$fieldName];
		$path_uploadfolder = "/".$fieldConf['config']['uploadfolder'];
		if (substr($path_uploadfolder, -1) != "/") {
			$path_uploadfolder = $path_uploadfolder . "/"; // добавляем слэш, если его нет в конце
		}

		$falEditIconEnable = $fieldConf['config']['falEditIconEnable'];
		if ($falEditIconEnable == TRUE // при условии, что кнопки на редактирование файлово разрешены в config.колонки
			&& (
					$fieldConf['config']['internal_type'] == "file" # OR
					# $fieldConf['config']['internal_type'] == "file_reference" OR
					# $fieldConf['config']['internal_type'] == "folder"
				)
		) {
		
				// Чистим не разарешенные форматы файлов (исправляем баг - загрузаются все форматы файлов)
			$uidList = $this->validFormat($uidList, $fieldConf, $tableName, $fieldName, $idRecord);

				// Вставляем информацию о файлах, если их не существует
			$this->inserFileInfoIfNotCratedFileInfo($path_uploadfolder, $uidList);

				// Извлекаем инфомрацию о файлах
			$fileListArrayInfo = $this->selectFileInfo($path_uploadfolder, $uidList);
			$allListUidFiles = array();
			foreach ($fileListArrayInfo as $key => $value) {
				$allListUidFiles[] = $value['uid'];
			}

				// Меняем Select
			$selector = $this->modifSelect($selector, $fieldConf, $fileListArrayInfo);

				// Добавляем в onchange()
			foreach ($icons['L'] as $kL => $vL){
				$icons['L'][$kL] = str_replace("; return false", "; ".$this->onchange_select_file_list."(); return false", $vL);
			}
			
				// Если есть присоединенные файлы, то добавляем кнопку редактоировать
			if (count($uidList) > 0) {
				$onClick = t3lib_BEfunc::editOnClick('&edit[sys_file_uploads]['.implode("," , $allListUidFiles).']=edit&parentRecordInfo[table]='.$tableName.'&parentRecordInfo[id]='.$idRecord,'');
				$icons['R'][] = '
					<span style="white-space: nowrap; line-height: 16px;">
					<a href="#" onclick="'.htmlspecialchars($onClick).'" title="FAL-editing">
						<img' . t3lib_iconWorks::skinImg($GLOBALS['BACK_PATH'], t3lib_extMgm::extRelPath('air_table').'hooks/fal-edit-icon.png', 'width="16" height="16"') . ' style="vertical-align: middle;">
							<!--Рдактировать описание-->
					</a>
					</span>
					<br />
				';
			}
		}

	}
	
		// Чистим не разарешенные форматы файлов (исправляем баг - загрузаются все форматы файлов)
	function validFormat($uidList, $fieldConf, $tableName, $fieldName, $recordId) {
	
			// Проверяем "config.allowed = *" и "config.disallowed = php,php3"
		$allowed = "[".str_replace(",","][",$fieldConf['config']['allowed'])."]";
		$allowed = str_replace(' ', '', $allowed); // убираем пробелы, т.к. они могут быть
		$disallowed = "[".str_replace(",","][",$fieldConf['config']['disallowed'])."]";
		$disallowed = str_replace(' ', '', $disallowed); // убираем пробелы, т.к. они могут быть
		
			// Исключаем файлы с не разарешенными форматами
		foreach ($uidList as $k => $v) {
			
				// Получаем разрешение файла
			$extension = strtolower($this->getExtension1($v));

				// По умолчанию файл не расшрешен
			$allowFile = 0; //
						
				// Сначала проверяем разрешен ли файл?
			if (strstr($allowed, "[*]") OR trim($allowed) == "[]" OR strstr($allowed, "[{$extension}]")) {
				$allowFile = 1;
			}
				
				// После проверяем не запрещен ли файл?
			if (strstr($disallowed, "[{$extension}]")) {
				$allowFile = 0;
			}
						
				// Да файл разрешен!
			if ($allowFile == 1) {
				$rowListFileAllowed[] = $v;
			} else {
				$listExtDisabled[] = $extension;
				// Запрещен
			}

		}
		
			// Вывод сообщения о том, какие форматы не льзя было загрузать
		if (count ($listExtDisabled) > 0) {
			$o_flashMessage = t3lib_div::makeInstance(
				't3lib_FlashMessage',
				'Не допускается присоединять запрещенные форматы файлов: '.implode(",", $listExtDisabled).'.',
				'Недопустимые форматы файлов',
				1,
				t3lib_FlashMessage::ERROR
			);
			t3lib_FlashMessageQueue::addMessage($o_flashMessage);
		}
			
			// Обновляем также в БД
		$queryUpdate = "UPDATE {$tableName} SET {$fieldName} = '".implode(",", $rowListFileAllowed)."' WHERE uid='{$idRecord}' LIMIT 1;";
		$GLOBALS['TYPO3_DB']->sql_query($queryUpdate); 
								
			// Отправляем с разрешенными форматами
		return $rowListFileAllowed;
	}

		// Если каких-то файлов с данным идентификатором не существует всатвляем из в БД
	function inserFileInfoIfNotCratedFileInfo($path, $uidList) {
		foreach ($uidList as $key => $value) {
			$res = $GLOBALS['TYPO3_DB']->sql_query("SELECT uid FROM sys_file_uploads WHERE identifier_md5 = '".md5($path.$value)."'");
			if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) == null) {
				$data['sys_file_uploads']['NEW'] = array(
					"pid" => 0,
					"identifier" => $path.$value,
					"identifier_md5" => md5($path.$value),
					"name" => $value,
					"title" => "--",
					"tstamp" => time(),
					"crdate" => time(),
					"size" => filesize(PATH_site.ltrim($path, "/").$value),
					"mime_type" => mime_content_type(PATH_site.ltrim($path, "/").$value),
					"extension" => $this->getExtension1(PATH_site.ltrim($path, "/").$value)
				);
				$tce = t3lib_div::makeInstance ('t3lib_TCEmain');
				$tce->start ($data, array());
				$tce->process_datamap ();
				# $last_insert_id = $tce->substNEWwithIDs['NEW']; //вставленный ID-записи;
			}
		}
	}

		// Получить информацию о файлах
	function selectFileInfo($path, $uidList) {
		foreach ($uidList as $key => $value) {
			$IN[] = "'".md5($path . $value)."'";
			$FIND[] = md5($path . $value);
		}
		$res = $GLOBALS['TYPO3_DB']->sql_query('
			SELECT * FROM sys_file_uploads
			WHERE identifier_md5 IN ('.implode (",", $IN).')
			ORDER BY FIND_IN_SET( identifier_md5, "'.implode (",", $FIND).'" )
		');
		$rowListFile = array();
		while( $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			if (trim($row['title']) == null) {
				$row['title'] = "--";
			}
			$rowListFile[] = $row;
		}
		return $rowListFile;
	}
	
		// Меняем Select
	function modifSelect($selector, $fieldConf, $rowListFile) {
		/*
			<select id="tceforms-multiselect-53e66539d3cf0" size="5" class="formField1 tceforms-multiselect" multiple="multiple" name="data[tt_content][106][image]_list"  style="width:310px;">
			<option value="DSC07823.png" title="DSC07823.png">DSC07823.png</option><option value="DSC07824.png" title="DSC07824.png">DSC07824.png</option>
			<option value="DSC07828.png" title="DSC07828.png">DSC07828.png</option><option value="DSC07831.png" title="DSC07831.png">DSC07831.png</option>
			<option value="DSC07834.png" title="DSC07834.png">DSC07834.png</option></select>
			Array
			(
				[0] => Array
					(
						[0] => <option value="DSC07823.png" title="DSC07823.png">DSC07823.png</option>
						[1] => <option value="DSC07824.png" title="DSC07824.png">DSC07824.png</option>
						[2] => <option value="DSC07828.png" title="DSC07828.png">DSC07828.png</option>
						[3] => <option value="DSC07831.png" title="DSC07831.png">DSC07831.png</option>
						[4] => <option value="DSC07834.png" title="DSC07834.png">DSC07834.png</option>
					)

				[1] => Array
					(
						[0] =>  value="DSC07823.png" title="DSC07823.png"
						[1] =>  value="DSC07824.png" title="DSC07824.png"
						[2] =>  value="DSC07828.png" title="DSC07828.png"
						[3] =>  value="DSC07831.png" title="DSC07831.png"
						[4] =>  value="DSC07834.png" title="DSC07834.png"
					)

				[2] => Array
					(
						[0] => DSC07823.png
						[1] => DSC07824.png
						[2] => DSC07828.png
						[3] => DSC07831.png
						[4] => DSC07834.png
					)

			)

		*/
	
			// Получаем id-из selecta и значения <option>
		preg_match_all('/<select([^\>]*)>/is', $selector, $matches_select);
		preg_match_all('/<option([^\>]*)>([^>]*)<\/option>/is', $selector, $matches_option);
		preg_match_all('/(id)="([^"]*)"/i', $matches_select[1][0], $idSelect);
		$idSelect = $idSelect[2][0];
		$idSelect_with_underscore = str_replace("-", "_", $idSelect);
		$maxitems = $fieldConf['config']['maxitems'];
		
		$this->onchange_select_file_list = "onchange_select_file_list_" . $idSelect_with_underscore;
		$newSelectOut = "
				<script>
				
						// Функция меняет местами div-ы
					function onchange_select_file_list_" . $idSelect_with_underscore . "(){
						
							// Сначала собираем всю коллекцию div-ов
						var allListDivElem = new Array();
						var objAllListFile_div_elems = document.getElementById('".$idSelect_with_underscore."_wrapAllListFile');
						var children = objAllListFile_div_elems.childNodes;
						for(var i=0;i<children.length; i++) {
							if (children[i].nodeType == 1) {
								var child = children[i]
								if (child.className == 'file_element_in_list') {
									//alert(children[i].outerHTML);
									//alert(child.style.background);
									//alert(child.getAttribute('data-role-value'));
									allListDivElem[child.getAttribute('data-role-value')] = child.outerHTML;
								}
							}
						}
						
							// После читаем положения <option по value>
							// И собираем для innerHTML-последовательность div-ов 
						var allListDivElemNewPosition = '';
						var objSel = document.getElementById('".$idSelect."');
						for (var i=0; i < objSel.options.length; i++) {
							//alert(objSel.options[i].text);
							allListDivElemNewPosition += allListDivElem[objSel.options[i].value];
						}
						
							// Присваиваем новую последовательность!
							// Если пусто
						if (allListDivElemNewPosition == '') {
							document.getElementById('".$idSelect_with_underscore."_wrapAllListFile').innerHTML = document.getElementById('".$idSelect_with_underscore."_nullFiles').outerHTML;
							document.getElementById('".$idSelect_with_underscore."_nullFiles').style.display = 'block';
						} else {
							// Если есть содержимое
							document.getElementById('".$idSelect_with_underscore."_wrapAllListFile').innerHTML = allListDivElemNewPosition;
						}
						
							// Отмечаем ckeck-боксы
						var objSel = document.getElementById('".$idSelect."');
						for (var i=0; i < objSel.options.length; i++) {
							if (objSel.options[i].selected == 1) {
								// alert(objSel.options[i].getAttribute('data-role-box-ckecked'));
								//var inputCkeckboxId = objSel.options[i].getAttribute('data-role-box-ckecked');
								//document.getElementById(inputCkeckboxId).checked = true;
									// Ищем в div-е input-ы
									var elms = document.getElementById('".$idSelect_with_underscore."_wrapAllListFile').getElementsByTagName('*');
									for (var j = 0; j < elms.length; j++) {
										if (elms[j].tagName == 'INPUT') {
											//alert(elms[j].tagName);
											if (objSel.options[i].value == elms[j].value){
												elms[j].checked = true;
												break;
											}
										}
									}
							}
						}
						
					}

						// Функция отмечает элементы в select при нажатии на checkbox
					function click_ckeckbox_file_element_" . $idSelect_with_underscore . "(obj){
						var objSel = document.getElementById('".$idSelect."');
						if (obj.checked) {
							// alert('Флажок установлен' + obj.value);
							for (var i=0; i < objSel.options.length; i++)
							  {
								  if (objSel.options[i].value == obj.value){
									objSel.options[i].selected = 1;
								  }
							  }
						} else {
							// alert('Флажок не установлен' + obj.value);
							for (var i=0; i < objSel.options.length; i++)
							  {
								  if (objSel.options[i].value == obj.value){
									objSel.options[i].selected = 0;
								  }
							  }
						}
					}
				</script>";
		
		$newSelectOut .= "<select style='display: none;' onchange='onchange_select_file_list_" . $idSelect_with_underscore . "();'" . $matches_select[1][0] . ">";
		# for ($i = 0; $i < count($matches_option[0]); $i++){
			# $number = $i + 1;
			# $number = str_pad($number, strlen($maxitems), '0', STR_PAD_LEFT); // добавляем ведущие "0" к числу
			# $newSelectOut .= "<option " . $matches_option[1][$i] . ">";
			# $newSelectOut .= "№" . ($number) . ". " . $matches_option[2][$i];
			# $newSelectOut .= "</option>";
			for($i = 0; $i < count($rowListFile); $i++) {
				$newSelectOut .= "<option value='".$rowListFile[$i]['name']."'>".$rowListFile[$i]['name']."</option>";
			}
		# }
		$newSelectOut .= "</select>";
		$newSelectOut .= "
		<style>
		.nobriconThumb {
			display: block;
			height: 60px;
			width: 60px;

			background-color: #CCCCCC;
			overflow-x: hidden;
			overflow-y: hidden;

			text-align: center;
			white-space: nowrap;
			cursor: pointer;
		}
		.nobriconThumb a { display: block; line-height: 60px; }
		.nobriconThumb img {
			margin: 0;
			padding: 0;
			vertical-align: middle;
			text-align: center;
		}
		</style>
		<div style='border: #b7b7b7 1px solid; background-color: white; min-width: 420px; margin-right: 10px; max-width: 500px;'>
		<div style='margin: 10px; margin-bottom: 0;' id='".$idSelect_with_underscore."_wrapAllListFile'>";
		
			for($i = 0; $i < count($rowListFile); $i++) {
		
				$newSelectOut .= "
					<div class='file_element_in_list' data-role-value='".$rowListFile[$i]['name']."' style='position: relative; margin-bottom: 10px;'>
					<label for='element_File_Id_".$idSelect_with_underscore."_".md5($rowListFile[$i]['identifier'])."' style='cursor: pointer;'>
					<div style='overflow: hidden; padding: 3px; padding-right: 25px; ".(($rowListFile[$i]['hidden'] == 1) ? 'opacity: 0.8' : '')."'>
				";
					
					$newSelectOut .= "<table border='0' cellpadding='0' cellspacing='0'>";
					$newSelectOut .= "<tr>";
					$newSelectOut .= "<td width='25'>";
					$newSelectOut .= 	t3lib_iconWorks::getSpriteIconForRecord('sys_file_uploads', $rowListFile[$i]);
					$newSelectOut .= "</td>";
					$newSelectOut .= "<td>";
					
						// Изображения
					if (strstr($rowListFile[$i]['mime_type'], "image/")) {
						# $iconThumb = t3lib_BEfunc::getThumbNail('thumbs.php', PATH_site.ltrim($rowListFile[$i]['identifier'], "/"), 'style="margin-right: 5px;"', 100);
						$iconThumb = t3lib_BEfunc::thumbCode(array('basename' => $rowListFile[$i]['name']), '', 'basename', '', '', ltrim(dirname($rowListFile[$i]['identifier']),'/'), '', 'style="vertical-align: middle;"', '60');
						$newSelectOut .= "<span class='nobriconThumb'>".$iconThumb."</span>";
					} else {
						// Документы
						$iconFileType = t3lib_iconWorks::getSpriteIconForFile($rowListFile[$i]['extension']);
						$newSelectOut .= "<a href='".($rowListFile[$i]['identifier'])."' target='_blank'>".$iconFileType."</a>";	
					}
					
					$newSelectOut .= "</td>";
					$newSelectOut .= "<td align='left'>";
					$newSelectOut .= "<div style='padding-left: 8px; padding-right: 10px;'>";
					
						$newSelectOut .= "<span style=''><a href='".($rowListFile[$i]['identifier'])."' target='_blank'>" .  basename($rowListFile[$i]['identifier']) . "</a></span>";
						if ($rowListFile[$i]['title'] != null && $rowListFile[$i]['title'] != "--") {
							$newSelectOut .= "<br /><b style=''>" . $rowListFile[$i]['title'] . "</b>";
						}
						if ($rowListFile[$i]['description'] != null) {
							$newSelectOut .= "<br /><i style='color: gray;'>" . $rowListFile[$i]['description'] . "</i>";
						}
					
					$newSelectOut .= "</div>";
					$newSelectOut .= "</td>";
					$newSelectOut .= "</tr>";
					$newSelectOut .= "</table>";
						
						$newSelectOut .= "<div style='position: absolute; right: 25px; top: 3px; color: gray;'>№" . ($i+1) . "</div>";
						$newSelectOut .= "<div style='position: absolute; top: 5px; right: 5px; color: gray;'>
											<input 
												id='element_File_Id_".$idSelect_with_underscore."_".md5($rowListFile[$i]['identifier'])."'
												type='checkbox' 
												value='".$rowListFile[$i]['name']."' 
												onclick='click_ckeckbox_file_element_" . $idSelect_with_underscore . "(this);'>
											</div>";
								
				$newSelectOut .= "</div>";
				$newSelectOut .= "</label>";
				$newSelectOut .= "</div>";
					
					// Разделитель
				if ($i < count($rowListFile)-1){
					# $newSelectOut .= "<span style='display: block; border-bottom: gray 1px dashed; height: 3px;'></span>";
				}
		}
	
			// Нулевой результат
		if (count($rowListFile) == 0) {
		$newSelectOut .= "
			<div style='padding-bottom: 10px;'>
				<i style='color: gray;'>
					В данной колонке нет присоединенных файлов. Максимальное <br /> 
					количество присоединяемых файлов - ".$maxitems.".
				</i>
			</div>";
		}
		
		$newSelectOut .= "
		</div>
		</div>
		";
		
				// Нулевой результат (для Javascript)
		$newSelectOut .= "
			<div style='padding-bottom: 10px; display: none;' id='".$idSelect_with_underscore."_nullFiles'>
				<i style='color: gray;'>
					В данной колонке нет присоединенных файлов. Максимальное <br /> 
					количество присоединяемых файлов - ".$maxitems.".
				</i>
			</div>";
		
		return $newSelectOut;
	}

		// Получить тип файла
	function getExtension1($filename) {
		return end(explode(".", $filename));
	}

}

?>